addHook("MobjDeath", function(mo)
	local player = mo.player
	if player
	and player.cos_deathsound
	and player.cos_deathsound > 0
	and player.cos_deathsound <= #Cosmetics.Deathsounds
		S_StartSound(mo, Cosmetics.Deathsounds[player.cos_deathsound].sound)
	end
end, MT_PLAYER)

addHook("HurtMsg", function(victimplayer, inflictor, source)
	local player
	if source and source.player
		player = source.player
	end
	if inflictor and inflictor.player
		player = inflictor.player
	end
	if player
	and player.cos_hitsound
	and player.cos_hitsound > 0
	and player.cos_hitsound <= #Cosmetics.Hitsounds
		S_StartSound(nil, Cosmetics.Hitsounds[player.cos_hitsound].sound, player)
	end
	return false
end)

addHook("PlayerMsg", function(player, audience, target, message)
	local ignore = false
	if ignorelist != nil
		for i = 1, #ignorelist
			if ignorelist[i] == player
				return true
			end
		end
	end
	
	if audience >= 2--Below code only applies to regular chat messages, not sayto or csay
		return false
	end
	if audience == 1 and (not isdedicatedserver) and consoleplayer and consoleplayer.ctfteam != player.ctfteam --Prevent team messages from showing to the wrong players
		return true
	end
	
	if player.cos_chatsound
	and player.cos_chatsound
	and player.cos_chatsound > 0
	and player.cos_chatsound <= #Cosmetics.Chatsounds
		S_StartSoundAtVolume(nil, Cosmetics.Chatsounds[player.cos_chatsound].sound, 170)
	end
	
	if juggy return false end//thanks Pikaspoop
	
	local color = skincolors[player.skincolor].chatcolor
	local col_table = 
	{
		[V_GRAYMAP] = "\x86",
		[V_REDMAP] = "\x85",
		[V_BROWNMAP] = "\x8d",
		[V_GREENMAP] = "\x83",
		[V_AZUREMAP] = "\x8c",
		[V_PURPLEMAP] = "\x89",
		[V_ROSYMAP] = "\x8e",
		[V_ORANGEMAP] = "\x87",
		[V_YELLOWMAP] = "\x82",
		[V_PERIDOTMAP] = "\x8b",
		[V_AQUAMAP] = "\x8a",
		[V_SKYMAP] = "\x88",
		[V_BLUEMAP] = "\x84",
		[V_MAGENTAMAP] = "\x81",
		[V_INVERTMAP] = "\x86"--inverted chat would look annoying...
	}
	local namecol = col_table[color]
	if namecol == nil
		namecol = "\x80"
	end
	local messagecol = "\x80"
	
	if player.spectator
		namecol = "\x86"
		messagecol = "\x86"
	end
	local printtext
	if audience == 1
		if player.spectator
			namecol = "\x80"
			printtext = namecol.."[SPEC]"
		else
			printtext = namecol.."[TEAM]"
		end
		messagecol = namecol
	else
		printtext = namecol
	end
	if IsPlayerAdmin(player)
		chatprint(printtext.."<\x82@"..namecol..player.name.."> "..messagecol..message.."\x86")
	elseif player == server
		chatprint(printtext.."<\x82~"..namecol..player.name.."> "..messagecol..message.."\x86")
	else
		chatprint(printtext.."<"..player.name.."> "..messagecol..message.."\x86")
	end
	return true
end)