freeslot(
	"S_HAT1","SPR_HAT1",
	"S_HAT3","SPR_HAT3",
	"S_HAT5","SPR_HAT5",
	"S_HAT6","SPR_HAT6",
	"S_HAT7","SPR_HAT7",
	"S_HAT8","SPR_HAT8",
	"S_HAT9","SPR_HAT9",
	"S_BURG","SPR_BURG",
	"S_GROM","SPR_GROM",
	"S_MAJO","SPR_MAJO",
	"S_BHAT","SPR_BHAT",
	"S_SOMB","SPR_SOMB",
	"S_GLAS","SPR_GLAS",
	"S_SGLS","SPR_SGLS",
	"S_BDAY","SPR_BDAY",
	"S_DNCE","SPR_DNCE",
	"S_BOWT","SPR_BOWT"
)
states[S_HAT1].sprite = SPR_HAT1
states[S_HAT3].sprite = SPR_HAT3
states[S_HAT5].sprite = SPR_HAT5
states[S_HAT6].sprite = SPR_HAT6
states[S_HAT7].sprite = SPR_HAT7
states[S_HAT8].sprite = SPR_HAT8
states[S_HAT9].sprite = SPR_HAT9
states[S_BURG].sprite = SPR_BURG
states[S_GROM].sprite = SPR_GROM
states[S_MAJO].sprite = SPR_MAJO
states[S_BHAT].sprite = SPR_BHAT
states[S_SOMB].sprite = SPR_SOMB
states[S_GLAS].sprite = SPR_GLAS
states[S_SGLS].sprite = SPR_SGLS
states[S_BDAY].sprite = SPR_BDAY
states[S_DNCE].sprite = SPR_DNCE
states[S_BOWT].sprite = SPR_BOWT
for i = S_HAT1, S_BOWT
	states[i].tics = -1 --Prevents the hat from disappearing instantly
end

local sparkle = function(mo)
	if leveltime % 15 == 0
		local fl = P_MobjFlip(mo.target)
		local star = P_SpawnMobj(mo.x,mo.y,mo.z + (12 * FRACUNIT * fl),MT_SPINDUST)
		star.momz = (2 * FRACUNIT) * fl
		star.fuse = 16
		star.state = S_NIGHTSPARKLE1
		star.color = SKINCOLOR_YELLOW
		star.colorized = true
	end
end

//Cosmetics.AddHat(name,					artist,				hudsprite,	state,	ismask,	thinker)
Cosmetics.AddHat("Dapper Hog",				"Chuckles Troll",	"HAT1A0",	S_HAT1, false,	nil)
Cosmetics.AddHat("OVA Hat",					"lightdasher",		"HAT3A2A8",	S_HAT3, false,	nil)
Cosmetics.AddHat("Champion's Crown",		"Inazuma",			"HAT5A0",	S_HAT5, false,	sparkle)
Cosmetics.AddHat("Hatdog",					"Chuckles Troll",	"HAT6A0",	S_HAT6, false,	nil)
Cosmetics.AddHat("Cosmic Jester",			"Ice Face",			"HAT7A2",	S_HAT7, false,	nil)
Cosmetics.AddHat("Chieftain's Challenge",	"lightdasher",		"HAT8A2A8",	S_HAT8, true,	nil)
Cosmetics.AddHat("Popgun Prankster",		"lightdasher",		"HAT9A2A8",	S_HAT9, false,	nil)
Cosmetics.AddHat("Burger",					"Chuckles Troll",	"BURGA0",	S_BURG, false,	nil)
Cosmetics.AddHat("gromit mug",				"Chuckles Troll",	"GROMA0",	S_GROM, false,	nil)
Cosmetics.AddHat("Majora's Mask",			"lightdasher",		"MAJOA2A8",	S_MAJO, true,	nil)
Cosmetics.AddHat("Air Bubble",				"lightdasher",		"BHATA0",	S_BHAT, false,	nil)
Cosmetics.AddHat("La Amiga",				"lightdasher",		"SOMBA2A8",	S_SOMB, false,	nil)
Cosmetics.AddHat("Glasses",					"Chuckles Troll",	"GLASA2A8",	S_GLAS, false,	nil)
Cosmetics.AddHat("Sunglasses",				"Chuckles Troll",	"SGLSA2A8",	S_SGLS, false,	nil)
Cosmetics.AddHat("Birthday Hat",			"lightdasher",		"BDAYA0",	S_BDAY, false,	nil)
Cosmetics.AddHat("Dunce Cap",				"lightdasher",		"DNCEA0",	S_DNCE, false,	nil)
Cosmetics.AddHat("Bowtie",					"lightdasher",		"BOWTA2A8",	S_BOWT, true,	nil)