rawset(_G, "Cosmetics", {})

local getkey = function(str)
	return string.gsub(str, " ", "")
end

Cosmetics.Hats = {}
Cosmetics.AddHat = function(name, artist, hudsprite, state, ismask, thinker)
	local index = #Cosmetics.Hats + 1
	Cosmetics.Hats[index] = {
		name = name,
		artist = artist,
		hudsprite = hudsprite,
		state = state,
		ismask = ismask,
		thinker = thinker,
		--key = getkey(name)
	}
	local hat = Cosmetics.Hats[index]
	print("Registered hat: "+hat.name+" by "+hat.artist)
	
	return index;
end

Cosmetics.Deathsounds = {}
Cosmetics.AddDeathsound = function(name, sound)
	local index = #Cosmetics.Deathsounds + 1
	Cosmetics.Deathsounds[index] = {
		name = name,
		sound = sound,
		--key = getkey(name)
	}
	local snd = Cosmetics.Deathsounds[index]
	print("Registered Deathsound: "+snd.name+" ("+snd.sound+")")
	
	return index;
end

Cosmetics.Hitsounds = {}
Cosmetics.AddHitsound = function(name, sound)
	local index = #Cosmetics.Hitsounds + 1
	Cosmetics.Hitsounds[index] = {
		name = name,
		sound = sound,
		--key = getkey(name)
	}
	local snd = Cosmetics.Hitsounds[index]
	print("Registered Hitsound: "+snd.name+" ("+snd.sound+")")
	
	return index;
end

Cosmetics.Chatsounds = {}
Cosmetics.AddChatsound = function(name, sound)
	local index = #Cosmetics.Chatsounds + 1
	Cosmetics.Chatsounds[index] = {
		name = name,
		sound = sound,
		--key = getkey(name)
	}
	local snd = Cosmetics.Chatsounds[index]
	print("Registered Chatsound: "+snd.name+" ("+snd.sound+")")
	
	return index;
end

Cosmetics.SkinOffsets = {}